package com.fireworksdk.bridge.utils

import com.google.gson.Gson
import java.lang.reflect.Type

object FWGsonUtil {

  private val gson by lazy {
    Gson()
  }

  fun toJson(ts: Any?): String? {
    return gson.toJson(ts)
  }

  fun <T> fromJson(json: String?, type: Class<T>): T? {
    if (json.isNullOrBlank()) {
      return null
    }
    return gson.fromJson(json, type)
  }

  fun <T> fromJson(json: String?, type: Type): T? {
    if (json.isNullOrBlank()) {
      return null
    }
    return gson.fromJson(json, type)
  }

  fun <T> fromObject(o: Any?, type: Class<T>): T? {
    if (o == null) {
      return null
    }
    val jsonString = toJson(o)
    return gson.fromJson(jsonString, type)
  }

}
