//
//  RCTConvert+FWVideoFeed.swift
//  react-native-firework-sdk
//
//  Created by Jeff Zheng on 2021/12/22.
//

import FireworkVideo
import Foundation

extension VideFeedSourceType {
    static var sourceTypeMapper: [String: VideFeedSourceType] {
        [
            "discover": .discover,
            "channel": .channel,
            "playlist": .playlist,
            "playlistGroup": .playlistGroup,
            "dynamicContent": .dynamicContent
        ]
    }
}

extension VideoFeedMode {
    static var feedModeMapper: [String: VideoFeedMode] {
        [
            "row": .row,
            "column": .column,
            "grid": .grid
        ]
    }
}

@objc
extension RCTConvert {
    public static func videoFeedSourceType(_ type: String?) -> VideFeedSourceType {
        guard let rType = type else {
            return .discover
        }

        return VideFeedSourceType.sourceTypeMapper[rType] ?? .discover
    }

    public static func videoFeedMode(_ type: String?) -> VideoFeedMode {
        guard let rType = type else {
            return .row
        }

        return VideoFeedMode.feedModeMapper[rType] ?? .row
    }
}
