//
//  FireworkJsEvent.swift
//  react-native-firework-sdk
//
//  Created by Jeff Zheng on 2021/12/21.
//

import Foundation

/// Video event
enum FWEventName: String, CaseIterable {
    case sdkInit = "fw:sdk-init"
    case customCTAClick = "fw:custom-cta-click"
    case videoPlayback = "fw:video-playback"
    case videoFeedClick = "fw:video-feed-click"
}

enum VideoPlaybackSubEventName: String {
    case impression = "fw:video:impression"
    case start = "fw:video:start"
    case firstQuartile = "fw:video:first-quartile"
    case midpoint = "fw:video:midpoint"
    case thirdQuartile = "fw:video:third-quartile"
    case complete = "fw:video:complete"
    case adEnd = "fw:video:ad-end"
    case clickCTA = "fw:video:click-cta"
    case clickShare = "fw:video:click-share"
}

/// Shopping event
enum ShoppingEventName: String, CaseIterable {
    case updateProductDetails = "fw:shopping:update-product-details"
    case willDisplayProduct = "fw:shopping:will-display-product"
    case addToCart = "fw:shopping:add-to-cart"
    case clickCartIcon = "fw:shopping:click-cart-icon"
}

/// Live stream event
enum LiveStreamEventName: String, CaseIterable {
    case livestream = "fw:livestream"
    case livestreamChat = "fw:livestream-chat"
}

enum LiveStreamSubEventName: String {
    case userDidjoin = "fw:livestream:user-join"
    case userDidLeave = "fw:livestream:user-leave"
    case userSendLike = "fw:livestream:user-send-like"
}

enum LiveStreamChatSubEventName: String {
    case userSendChat = "fw:livestream:user-send-chat"
}

enum VideoFeedEventName: String {
    case onVideoFeedLoadFinished
}

enum StoryBlockEventName: String {
    case onStoryBlockLoadFinished
}
