//
//  File.swift
//  fw_flutter_sdk
//
//  Created by Jeff Zheng on 2022/2/21.
//

import Flutter
import Foundation

@objc(SwiftFireworkFlutterSdkPlugin)
public class SwiftFireworkFlutterSdkPlugin: NSObject, FlutterPlugin {

    /// When use click cart icon on shoppable video, FireworkSDK will call this callback to push cart page.
    public static var customCartPageProvider: (() -> FlutterViewController)?

    /// Description
    public static var navigatorPageProvider: (([String: Any]?) -> FlutterViewController?)?

    public static func register(with registrar: FlutterPluginRegistrar) {
        FireworkSDKModulePlugin.register(with: registrar)
        ShoppingModulePlugin.register(with: registrar)
        LiveStreamModulePlugin.register(with: registrar)
        FireworkFlutterModulePlugin.register(with: registrar)
        FireworkNavigatorModule.register(with: registrar)

        let videoFeedViewFactory = VideoFeedViewFactory(messenger: registrar.messenger())
        registrar.register(videoFeedViewFactory, withId: FWChannelName.fireworkVideoFeed.rawValue)

        let storyBlockViewFactory = StoryBlockViewFactory(messenger: registrar.messenger())
        registrar.register(storyBlockViewFactory, withId: FWChannelName.fireworkStoryBlock.rawValue)
    }
}
