//
//  AVPlayer+FWSwizzle.m
//  FireworkSdk
//
//  Created by linjie jiang on 2023/1/10.
//

#import "AVPlayer+FWSwizzle.h"
#import <objc/runtime.h>
#if __has_include(<fw_flutter_sdk/fw_flutter_sdk-Swift.h>)
#import <fw_flutter_sdk/fw_flutter_sdk-Swift.h>
#else
// Support project import fallback if the generated compatibility header
// is not copied when this plugin is created as a library.
// https://forums.swift.org/t/swift-static-libraries-dont-copy-generated-objective-c-header/19816
#import "fw_flutter_sdk-Swift.h"
#endif

@implementation AVPlayer (FWSwizzle)

+ (void)load {
    static dispatch_once_t once_token;
    dispatch_once(&once_token, ^{
        [self swizzleSelector:@selector(play) targetSelector:@selector(_fw_play)];
    });
}

+ (void)swizzleSelector:(SEL)sourceSelector
         targetSelector:(SEL)targetSelector {
    Class class = [self class];
    Method sourceMethod =
        class_getInstanceMethod(class, sourceSelector);
    Method targetMethod =
        class_getInstanceMethod(class, targetSelector);
    BOOL isMethodExists =
        !class_addMethod(class, sourceSelector,
            method_getImplementation(targetMethod),
            method_getTypeEncoding(targetMethod));
    if (isMethodExists) {
        method_exchangeImplementations(sourceMethod, targetMethod);
    } else {
        class_replaceMethod(class, targetSelector,
            method_getImplementation(sourceMethod),
            method_getTypeEncoding(sourceMethod));
        }
}

- (void)_fw_play {
    if (FWNavigatorUtils.shared.shouldDisablePlay) {
        return;
    }
    
    [self _fw_play];
}

@end
