import './models/fw_method_name.dart';
import './utils/fw_method_channel_util.dart';
import './utils/model_utils/fw_method_name_util.dart';

/// You can use this class for pushing Flutter page from the native page.
class FWNavigator {
  static FWNavigator? _instance;

  static FWNavigator _getInstance() {
    _instance ??= FWNavigator._();
    return _instance!;
  }

  FWNavigator._();

  factory FWNavigator.getInstance() => _getInstance();

  /// Push a new native container.
  Future<bool> pushNativeContainer(Map<String, dynamic>? arguments) async {
    final result =
        await FWMethodChannelUtil.getNavigatorMethodChannel().invokeMethod(
      FWNavigatorMethodNameUtil.convertToNativeMethod(
        FWNavigatorNativeMethodName.pushNativeContainer,
      ),
      arguments,
    );
    return result;
  }

  /// Pop top-most native container.
  Future<bool> popNativeContainer() async {
    final result =
        await FWMethodChannelUtil.getNavigatorMethodChannel().invokeMethod(
      FWNavigatorMethodNameUtil.convertToNativeMethod(
        FWNavigatorNativeMethodName.popNativeContainer,
      ),
    );
    return result;
  }

  /// Indicate if we can pop top-most native container.
  Future<bool> canPopNativeContainer() async {
    final result =
        await FWMethodChannelUtil.getNavigatorMethodChannel().invokeMethod(
      FWNavigatorMethodNameUtil.convertToNativeMethod(
        FWNavigatorNativeMethodName.canPopNativeContainer,
      ),
    );
    return result;
  }
}
