import 'package:flutter_test/flutter_test.dart';
import 'package:fw_flutter_sdk/src/models/fw_method_name.dart';
import 'package:fw_flutter_sdk/src/utils/model_utils/fw_method_name_util.dart';

void main() {
  test('FWMethodNameUtil', () {
    fwMethodNameMap.forEach(
      ((key, value) {
        expect(
          FWMethodNameUtil.createMethodName(key),
          value,
        );
      }),
    );
    for (var element in FWNativeMethodName.values) {
      expect(
        FWMethodNameUtil.convertToNativeMethod(element),
        element.toString().split(".").last,
      );
    }
  });

  test('FWShoppingMethodNameUtil', () {
    fwShoppingMethodNameMap.forEach(
      ((key, value) {
        expect(
          FWShoppingMethodNameUtil.createMethodName(key),
          value,
        );
      }),
    );
    for (var element in FWShoppingNativeMethodName.values) {
      expect(
        FWShoppingMethodNameUtil.convertToNativeMethod(element),
        element.toString().split(".").last,
      );
    }
  });

  test('FWVideoFeedMethodNameUtil', () {
    fwVideoFeedMethodNameMap.forEach(
      ((key, value) {
        expect(
          FWVideoFeedMethodNameUtil.createMethodName(key),
          value,
        );
      }),
    );
    for (var element in FWVideoFeedNativeMethodName.values) {
      expect(
        FWVideoFeedMethodNameUtil.convertToNativeMethod(element),
        element.toString().split(".").last,
      );
    }
  });

  test('FWLiveStreamMethodNameUtil', () {
    fwLiveStreamMethodNameMap.forEach(
      ((key, value) {
        expect(
          FWLiveStreamMethodNameUtil.createMethodName(key),
          value,
        );
      }),
    );
    for (var element in FWLiveStreamNativeMethodName.values) {
      expect(
        FWLiveStreamMethodNameUtil.convertToNativeMethod(element),
        element.toString().split(".").last,
      );
    }
  });

  test('FWNavigatorMethodNameUtil', () {
    for (var element in FWNavigatorNativeMethodName.values) {
      expect(
        FWNavigatorMethodNameUtil.convertToNativeMethod(element),
        element.toString().split(".").last,
      );
    }
  });

  test('FWStoryBlockMethodNameUtil', () {
    fwStoryBlockMethodNameMap.forEach(
      ((key, value) {
        expect(
          FWStoryBlockMethodNameUtil.createMethodName(key),
          value,
        );
      }),
    );
  });
}
