import 'package:flutter_test/flutter_test.dart';
import 'package:fw_flutter_sdk/src/models/product_info_view_configuration.dart';
import 'package:fw_flutter_sdk/src/utils/model_utils/product_info_view_configuration_util.dart';

void main() {
  test('ProductInfoViewConfigurationUtil toJson', () {
    final configuration = ProductInfoViewConfiguration(
      addToCartButton: AddToCartButtonConfiguration(
        backgroundColor: "#c0c0c0",
        fontSize: 16,
        textColor: "#000000",
      ),
    );

    final json = ProductInfoViewConfigurationUtil.toJson(configuration);
    final addToCartButtonJson = json["addToCartButton"];
    expect(addToCartButtonJson is Map<String, dynamic>, true);
    expect(addToCartButtonJson["backgroundColor"],
        configuration.addToCartButton?.backgroundColor);
    expect(addToCartButtonJson["fontSize"],
        configuration.addToCartButton?.fontSize);
    expect(addToCartButtonJson["textColor"],
        configuration.addToCartButton?.textColor);
  });
}
