import 'package:flutter_test/flutter_test.dart';
import 'package:fw_flutter_sdk/src/models/video_player_configuration.dart';
import 'package:fw_flutter_sdk/src/utils/model_utils/video_player_configuration_util.dart';

void main() {
  test('VideoPlayerConfigurationUtil toJson', () {
    final configuration = VideoPlayerConfiguration(
      playerStyle: VideoPlayerStyle.full,
      videoCompleteAction: VideoPlayerCompleteAction.advanceToNext,
      showShareButton: true,
      ctaButtonStyle: VideoPlayerCTAStyle(
        backgroundColor: "#c0c0c0",
        textColor: "#000000",
        fontSize: 16,
      ),
      showPlaybackButton: true,
      showMuteButton: true,
      launchBehavior: VideoLaunchBehavior.muteOnFirstLaunch,
      showBranding: true,
    );
    final json = VideoPlayerConfigurationUtil.toJson(configuration);
    expect(json["playerStyle"],
        configuration.playerStyle?.toString().split(".").last);
    expect(json["videoCompleteAction"],
        configuration.videoCompleteAction?.toString().split(".").last);
    expect(json["showShareButton"], configuration.showShareButton);
    expect(json["ctaButtonStyle"] is Map<String, dynamic>, true);
    final ctaButtonStyleJson = json["ctaButtonStyle"] as Map<String, dynamic>;
    expect(ctaButtonStyleJson["backgroundColor"],
        configuration.ctaButtonStyle?.backgroundColor);
    expect(ctaButtonStyleJson["textColor"],
        configuration.ctaButtonStyle?.textColor);
    expect(
        ctaButtonStyleJson["fontSize"], configuration.ctaButtonStyle?.fontSize);
    expect(json["showPlaybackButton"], configuration.showPlaybackButton);
    expect(json["showMuteButton"], configuration.showMuteButton);
    expect(json["launchBehavior"],
        configuration.launchBehavior?.toString().split(".").last);
    expect(json["showBranding"], configuration.showMuteButton);
  });
}
